precision mediump float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

void main()
{
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);

    highp float blueColor = textureColor.b * 15.0;

    highp vec2 quadf;
    quadf.y = floor(floor(blueColor) / 4.0);
    quadf.x = floor(blueColor) - (quadf.y * 4.0);

    highp vec2 quadc;
    quadc.y = floor(ceil(blueColor) / 4.0);
    quadc.x = ceil(blueColor) - (quadc.y * 4.0);

    highp vec2 texPosf;
    texPosf.x = (quadf.x * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.r);
    texPosf.y = (quadf.y * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.g);

    highp vec2 texPosc;
    texPosc.x = (quadc.x * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.r);
    texPosc.y = (quadc.y * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.g);

    lowp vec4 newColorf = texture2D(inputImageTexture2, texPosf);
    lowp vec4 newColorc = texture2D(inputImageTexture2, texPosc);

    lowp vec4 newMixColor = mix(newColorf, newColorc, fract(blueColor));

    gl_FragColor = mix(textureColor, newMixColor, 0.8);
}