precision mediump float;

varying vec2 textureindex;
varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform  sampler2D inputImageTexture2;
uniform  sampler2D inputImageTexture3;
uniform  sampler2D inputImageTexture4;

void main()
{
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);

    // step 1
    highp float blueColor = textureColor.b * 15.0;

    highp vec2 quadf;
    quadf.y = floor(floor(blueColor) / 4.0);
    quadf.x = floor(blueColor) - (quadf.y * 4.0);

    highp vec2 quadc;
    quadc.y = floor(ceil(blueColor) / 4.0);
    quadc.x = ceil(blueColor) - (quadc.y * 4.0);

    highp vec2 texPosf;
    texPosf.x = (quadf.x * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.r);
    texPosf.y = (quadf.y * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.g);

    highp vec2 texPosc;
    texPosc.x = (quadc.x * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.r);
    texPosc.y = (quadc.y * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.g);

    lowp vec4 newColorf = texture2D(inputImageTexture2, texPosf);
    lowp vec4 newColorc = texture2D(inputImageTexture2, texPosc);

    lowp vec4 newMixColor = mix(newColorf, newColorc, fract(blueColor));

    // inputImageTexture3
    vec4 lightness = texture2D(inputImageTexture3, textureindex);
    lightness.r = lightness.r/lightness.a;
    lightness.g = lightness.g/lightness.a;
    lightness.b = lightness.b/lightness.a;

    newMixColor.r = mix(newMixColor.r,texture2D( inputImageTexture4, vec2(lightness.r,newMixColor.r)).r, lightness.a);
    newMixColor.g = mix(newMixColor.g,texture2D( inputImageTexture4, vec2(lightness.g,newMixColor.g)).g, lightness.a);
    newMixColor.b = mix(newMixColor.b,texture2D( inputImageTexture4, vec2(lightness.b,newMixColor.b)).b, lightness.a);

    // last mix
    gl_FragColor = mix(textureColor, newMixColor, 0.8);

}