precision mediump float;

varying vec2 textureindex;
varying vec2 textureCoordinate;
uniform  sampler2D inputImageTexture;
uniform  sampler2D inputImageTexture2;
uniform  sampler2D inputImageTexture3;
uniform  sampler2D inputImageTexture4;
uniform  sampler2D inputImageTexture5;
uniform  sampler2D inputImageTexture6;

void main()
{
    highp vec4 textureColor = texture2D(inputImageTexture, textureCoordinate);

    // step 1
    highp float blueColor = textureColor.b * 15.0;

    highp vec2 quadf;
    quadf.y = floor(floor(blueColor) / 4.0);
    quadf.x = floor(blueColor) - (quadf.y * 4.0);

    highp vec2 quadc;
    quadc.y = floor(ceil(blueColor) / 4.0);
    quadc.x = ceil(blueColor) - (quadc.y * 4.0);

    highp vec2 texPosf;
    texPosf.x = (quadf.x * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.r);
    texPosf.y = (quadf.y * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.g);

    highp vec2 texPosc;
    texPosc.x = (quadc.x * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.r);
    texPosc.y = (quadc.y * 0.25) + 0.5/64.0 + ((0.25 - 1.0/64.0) * textureColor.g);

    lowp vec4 newColorf = texture2D(inputImageTexture2, texPosf);
    lowp vec4 newColorc = texture2D(inputImageTexture2, texPosc);

    lowp vec4 newMixColor = mix(newColorf, newColorc, fract(blueColor));

    // inputImageTexture 3 4
    vec4 overlay1 = texture2D(inputImageTexture3, textureindex);
    newMixColor.r = mix(newMixColor.r,texture2D( inputImageTexture4, vec2(overlay1.r,newMixColor.r)).r,1.0);
    newMixColor.g = mix(newMixColor.g,texture2D( inputImageTexture4, vec2(overlay1.g,newMixColor.g)).g,1.0);
    newMixColor.b = mix(newMixColor.b,texture2D( inputImageTexture4, vec2(overlay1.b,newMixColor.b)).b,1.0);

    // inputImageTexture 5 6
    vec4 overlay2 = texture2D(inputImageTexture5, textureindex);
    newMixColor.r = mix(newMixColor.r,texture2D( inputImageTexture6, vec2(overlay2.r,newMixColor.r)).r,1.0);
    newMixColor.g = mix(newMixColor.g,texture2D( inputImageTexture6, vec2(overlay2.g,newMixColor.g)).g,1.0);
    newMixColor.b = mix(newMixColor.b,texture2D( inputImageTexture6, vec2(overlay2.b,newMixColor.b)).b,1.0);

    gl_FragColor = mix(textureColor,newMixColor,0.8);
}