precision lowp float;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture1;
varying highp vec2 textureCoordinate;
const mediump float scaleRatio = 0.667;
const mediump float scaleRatioReverse = 1.5;

void main()
{
    float left = (1.0-scaleRatio)/2.0;
    float right = 1.0 - left;

    vec2 bl = step(vec2(left,left),textureCoordinate);
    float pct = bl.x * bl.y;
    vec2 tr = step(vec2(right, right),textureCoordinate);
    tr = 1.0-tr;
    pct *= tr.x * tr.y;

    lowp vec4 fragColor = texture2D(inputImageTexture, textureCoordinate);

    highp vec2 sampleCoord = (textureCoordinate - vec2(left, left)) * scaleRatioReverse;
    lowp vec4 originColor = texture2D(inputImageTexture1,sampleCoord);

    gl_FragColor = mix(fragColor, originColor, pct);

}