#extension GL_OES_EGL_image_external : require

precision highp float;

varying vec2 textureCoordinate;

uniform sampler2D s_texture;
uniform sampler2D inputImageTexture1;
uniform lowp int isFrontCamera;

void main() {
    highp vec2 bgCoord = vec2(1.0 - textureCoordinate.y, textureCoordinate.x);
    highp vec2 maskCoord = (isFrontCamera == 1 ? vec2(textureCoordinate.x, textureCoordinate.y) : vec2(1.0 - textureCoordinate.x, textureCoordinate.y));
    highp vec4 maskColor = texture2D(inputImageTexture1, maskCoord);
    highp vec4 bgColor = texture2D(s_texture, bgCoord);
    highp float alpha = maskColor.a;
    if (alpha < 1.0) {
        if (alpha > 0.5) {
            alpha = alpha * 0.2 + 0.8;
        } else if (alpha > 0.3 && alpha <= 0.5) {
            alpha = alpha * 3.0 - 0.6;
        } else {
            alpha = alpha;
        }
    }
    gl_FragColor = bgColor * alpha;
}