precision highp float;
uniform sampler2D inputImageTexture;

const lowp int GAUSSIAN_SAMPLES = 9;
const lowp int MAX_FACE_COUNT = 4;

varying highp vec2 textureCoordinate;
varying highp vec2 blurCoordinates[GAUSSIAN_SAMPLES];
uniform mediump float centerX;
uniform mediump float centerY;
uniform mediump int u_faceCount;
uniform mediump float factor;

uniform mat4 faceAreas;

void main()
{
    vec2 scaleVec2 = vec2(textureCoordinate.x, textureCoordinate.y * factor);
//    float dis = distance(scaleVec2.xy, vec2(centerX, centerY* factor));
//
//    float blurFactor = smoothstep(0.3, 0.4, dis);
    float blurFactor = 0.0;
    lowp vec3 sum = vec3(0.0);
    lowp vec4 fragColor = texture2D(inputImageTexture,textureCoordinate);
    sum += texture2D(inputImageTexture, blurCoordinates[0]).rgb * 0.05;
    sum += texture2D(inputImageTexture, blurCoordinates[1]).rgb * 0.09;
    sum += texture2D(inputImageTexture, blurCoordinates[2]).rgb * 0.12;
    sum += texture2D(inputImageTexture, blurCoordinates[3]).rgb * 0.15;
    sum += texture2D(inputImageTexture, blurCoordinates[4]).rgb * 0.18;
    sum += texture2D(inputImageTexture, blurCoordinates[5]).rgb * 0.15;
    sum += texture2D(inputImageTexture, blurCoordinates[6]).rgb * 0.12;
    sum += texture2D(inputImageTexture, blurCoordinates[7]).rgb * 0.09;
    sum += texture2D(inputImageTexture, blurCoordinates[8]).rgb * 0.05;
//    gl_FragColor = mix(fragColor, vec4(sum,fragColor.a),blurFactor);


//    if((u_faceCount > 0) && (scaleVec2.x < faceAreas[0][0] || scaleVec2.x > faceAreas[0][2] || scaleVec2.y < faceAreas[0][3] || scaleVec2.y > faceAreas[0][1])){
//        gl_FragColor = vec4(0,0,0,0);
//    }

    vec2 st = scaleVec2;


    highp float deltaY = 0.15 * (faceAreas[0][2]-faceAreas[0][0]);
    highp float deltaX = deltaY *factor;

      // bottom-left
      vec2 bl = smoothstep(vec2(faceAreas[0][0]-deltaX,faceAreas[0][3]-deltaY),vec2(faceAreas[0][0],faceAreas[0][3]),st);
      float pct = bl.x * bl.y;

      // top-right
      vec2 tr = smoothstep(vec2(faceAreas[0][2], faceAreas[0][1]),vec2(faceAreas[0][2]+deltaX, faceAreas[0][1]+deltaY),st);
      tr = 1.0-tr;
      pct *= tr.x * tr.y;


      deltaY = 0.15 * (faceAreas[0][2]-faceAreas[0][0]);
      deltaX = deltaY *factor;
       // bottom-left
      vec2 bl2 = smoothstep(vec2(faceAreas[1][0]-deltaX,faceAreas[1][3]-deltaY),vec2(faceAreas[1][0],faceAreas[1][3]),st);
      float pct2 = bl2.x * bl2.y;

      // top-right
      vec2 tr2 = smoothstep(vec2(faceAreas[1][2], faceAreas[1][1]),vec2(faceAreas[1][2]+deltaX, faceAreas[1][1]+deltaY),st);
      tr2= 1.0-tr2;
      pct2 *= tr2.x * tr2.y;




      deltaY = 0.15 * (faceAreas[0][2]-faceAreas[0][0]);
      deltaX = deltaY *factor;
       // bottom-left
      vec2 bl3 = smoothstep(vec2(faceAreas[2][0]-deltaX,faceAreas[2][3]-deltaY),vec2(faceAreas[2][0],faceAreas[2][3]),st);
      float pct3 = bl3.x * bl3.y;

      // top-right
      vec2 tr3 = smoothstep(vec2(faceAreas[2][2], faceAreas[2][1]),vec2(faceAreas[2][2]+deltaX, faceAreas[2][1]+deltaY),st);
      tr3= 1.0-tr3;
      pct3 *= tr3.x * tr3.y;



      highp float finalFactor = max(pct, pct2);
      finalFactor = max(finalFactor, pct3);

      blurFactor = 1.0-pow(finalFactor, 0.25);
      blurFactor = max(0.0, blurFactor);

      gl_FragColor = mix(fragColor,vec4(sum,fragColor.a),blurFactor);
}